package org.gyun.servlet;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.gyun.enity.User;
import org.gyun.service.UserService;
import org.gyun.service.impl.UserServiceImpl;

/**
 * 
 * @ClassNameUserServlet.java
 * @DescriptionHttpЭ顡̳javax.servlet.http.HttpServlet
 *                         GenericServletչĻHttpЭServlet
 * @AuthorDongGaoYun
 * @URL www.gyun.org
 * @EmailDongGaoYun@qq.com
 * @QQ1050968899
 * @WeiXinQingYunJiao
 * @Date2019-8-14 
 * @Version1.0
 */
@SuppressWarnings("serial")
public class UserServlet extends HttpServlet {

	/**
	 * ޲ι췽
	 */
	public UserServlet() {
		System.out.println("ʵ-----UserServlet--췽---->");
	}

	/**
	 * 
	 */
	public void destroy() {
		super.destroy();
		System.out.println("-----UserServlet---destroy--->");
	}
	//ҵ
	@Override
	public void service(ServletRequest req, ServletResponse res)
			throws ServletException, IOException {
		System.out.println("service-----UserServlet---ҵ--->");
		super.service(req, res);
	}
	//serviceķʽget,doGet
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		System.out.println("doGet-----UserServlet---doGet--->");

	}

	//serviceķʽpost,doPost
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		System.out.println("doPost-----UserServlet---doPost--->");

		String method = request.getParameter("method");
		//ͳӦĵ
		if ("listener".equals(method)) {
			String uname = request.getParameter("uname");
			//жϣעڶequalsжǷˣ
			if(uname!=null&&!uname.equals("")){
				User user=new User();
				user.setUname(uname);
				request.getSession().setAttribute("user", user);
				//listener ΪҰsuccesslistenerĿ¼£
				response.sendRedirect("listener/success.jsp");
			}else{
				// ҳʾϢ
				request.setAttribute("mess", "ûΪ");
				System.out.println("UserServlet------else---null->");
				request.getRequestDispatcher("listener/login.jsp").forward(request,
						response);
			}
		} else if ("login".equals(method)) {
			System.out.println("login--------------->" + method);
			String uname = request.getParameter("uname");
			String upass = request.getParameter("upass");
			User user = new User();
			user.setUname(uname);
			user.setUpass(upass);
			// 1.ݱUser
			// Ȼ󵽺̨ȥѯ
			UserService service = new UserServiceImpl();
			User users = service.getUserByUnameAndUpass(user);
			System.out.println("doPost---------->" + users);
			if (users != null && !users.equals("")) {
				// usersSession
				request.getSession().setAttribute("user", users);
				System.out
						.println("UserServlet------users != null&&users.equals(')---->"
								+ users.getUname() + users.getUpass());
				response.sendRedirect("success.jsp");
			} else {
				//ҳʾϢ
				request.setAttribute("mess", "û");
				System.out.println("UserServlet------else---->");
				request.getRequestDispatcher("login.jsp").forward(request,
						response);
			}
			System.out.println("doPost----end--UserServlet-->");
		} else {
			// upload.jspҳ
			// жǷ:multipart/form-data post
			// ϴļ
			// ȷ:ġFileItemFactoryServletFileUploadFileItem
			// ύͼƬļԪءжһ¡
			// ·ҲҪ
			// ҳԪغͼƬ(ļ)ȡķʽͬ
			// FileItemȡҪԪ:
			// ҳԪء(ڻȡgetParameterԪ);User
			// ϴļͼƬļͼƬõ,User
			// :service.add(User);
			// :
			// ʼ
			User user = new User();
			String uploadfilepath = null;
			String uploadfileName = null;
			// images
			uploadfilepath = request.getSession().getServletContext()
					.getRealPath("images/");
			System.out.println(uploadfilepath);
			File uploadnewname = new File(uploadfilepath);
			// Ŀ¼,Զһµ
			if (!uploadnewname.exists()) {
				uploadnewname.mkdir();
			}
			// жǷmultipart/form-data post
			boolean isMultipart = ServletFileUpload.isMultipartContent(request);
			if (isMultipart) {// multipart/form-data post
				// ϴĺ
				FileItemFactory factory = new DiskFileItemFactory();
				ServletFileUpload upload = new ServletFileUpload(factory);
				// 
				List<FileItem> fileitem = null;
				try {
					fileitem = upload.parseRequest(request);
				} catch (FileUploadException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				// 
				Iterator<FileItem> items = fileitem.iterator();
				while (items.hasNext()) {
					FileItem item = items.next();
					// Ԫ
					if (item.isFormField()) {
						String name = item.getFieldName();
						// ȡʵеͬԪغ,ԪطUser
						if ("uname".equals(name)) {
							user.setUname(item.getString("UTF-8"));
						} else if ("upass".equals(name)) {
							user.setUpass(item.getString("UTF-8"));
						} else if ("uremark".equals(name)) {
							user.setUremark(item.getString("UTF-8"));
						}
						System.out.println(user);
					} else {
						// ȡϴͼƬļ
						uploadfileName = item.getName();
						File file = new File(uploadfileName);
						user.setUfile(file.getName());
						// ñ·
						File filepath = new File(uploadfilepath, file.getName());
						// д·
						try {
							item.write(filepath);
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						System.out.println("ϴļ·:" + filepath);

					}

				}

			} else {// multipart/form-data post
				PrintWriter out = response.getWriter();
				out.println("ϵͳ!");
				out.close();

			}
			// javabean
			UserService service = new UserServiceImpl();
			service.save(user);
		}
	}

	/**
	 * Initialization of the servlet. <br>
	 * 
	 * @throws ServletException
	 *             if an error occurs
	 */
	public void init() throws ServletException {
		System.out.println("ʼ-----UserServlet---doGet--->");
	}

	@Override
	public void init(ServletConfig config) throws ServletException {
		String charsetEncoding = config.getInitParameter("charsetEncoding");
		String Charset = config.getServletContext().getInitParameter("Charset");
		System.out.println("init---config--charsetEncoding----->"
				+ charsetEncoding);
		System.out.println("init---getServletContext--Charset----->" + Charset);
		super.init(config);
	}

}
