package org.gyun.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.gyun.enity.User;

/**
 * 
 * @ClassNameUserServlet3.java
 * @Descriptionڶ̳֡javax.servlet.GenericServlet
 *                  Servletͨð汾һЭ޹صServlet
 * @AuthorDongGaoYun
 * @URL www.gyun.org
 * @EmailDongGaoYun@qq.com
 * @QQ1050968899
 * @WeiXinQingYunJiao
 * @Date2019-8-12 
 * @Version1.0
 */
public class LoginFilter implements Filter {
	public LoginFilter(){
		System.out.println("LoginFilter-------غʵ-------->");
	}
	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		System.out.println("LoginFilter-------Filterʼ------init->");

	}

	@Override
	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {
		System.out.println("LoginFilter-------˴------doFilter-start->");
		HttpServletRequest req = (HttpServletRequest) request;
		HttpServletResponse res = (HttpServletResponse) response;
		User user = (User) req.getSession().getAttribute("user");
		if (null == user) {
			System.out
					.println("LoginFilter-------˴------doFilter--if(null == user)--end->");
			request.getRequestDispatcher("login.jsp")
					.forward(request, response);
		} else {
			chain.doFilter(request, response);
			System.out
					.println("LoginFilter-------˴--doFilter--else--chain.doFilter-end->");
		}
	}

	@Override
	public void destroy() {
		System.out.println("LoginFilter-------Filter------destroy->");

	}

}
